function xnewtonm = newton_mod( f )
xin=inputdlg('Enter X');
xin=str2num(xin{1});

f=f;
syms x y;

%%%%%% FONC
f1=diff(f,x);
f2=diff(f,y);
deltaf=[f1;f2];
Xstar=solve(f1,f2);
%%%%%%%%

%%%%%%% SONC
f11=diff(f1,x);
f12=diff(f1,y);

f21=diff(f2,x);
f22=diff(f2,y);

H=[f11 f12;f21 f22];
for i=1:length(Xstar.x)
    x=Xstar.x(i);
    y=Xstar.y(i);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%


oldx=xin;

stop=0;


% % modified newton
syms alphak;
while(stop==0)
    

x=oldx(1);
y=oldx(2);
delta2=eval(H);

deltafx=-inv(delta2)*(eval(deltaf));
tempx=oldx+alphak.*deltafx;

x=tempx(1);
y=tempx(2);

fnew=eval(f);

% % Starting Fibonacci
fib_seq=zeros(1,50);
fib_seq(1)=1;
fib_seq(2)=2;
alpha_temp=[];
alpha_temp(1)=0;
found=0;
k=1;
% % getting initial bracket
while(found==0)
    alpha_temp(k+1)=alpha_temp(k)+0.01;
    alpha_temp(k+2)=alpha_temp(k+1)+0.01;
    
    alphak=alpha_temp(k);
    falpha_temp0=eval(fnew);
    
    alphak=alpha_temp(k+1);
    falpha_temp1=eval(fnew);
    
    alphak=alpha_temp(k+2);
    falpha_temp2=eval(fnew);
    
    if((falpha_temp1<falpha_temp0) && (falpha_temp1<falpha_temp2))
        alpha_bracket=[alpha_temp(k+1);alpha_temp(k+2)];
        L=alpha_bracket(2)-alpha_bracket(1);
        found=1;
    end
k=k+1;    
end

% % initial bracket alpha_bracket obtained

for i=2:49
    fib_seq(i+1)=fib_seq(i)+fib_seq(i-1);
end

FN1=(0.3)/((1+2*0.05)*(L));
FN1=round(FN1);


for i=1:50
    if(fib_seq(i)==FN1)
        N=i-1;        
    else if (fib_seq(i)<FN1 && fib_seq(i+1)>FN1)
            N=i-1;
        end
    end
    
end

if(N~=0)
for i=1:N
    if(i==N)
        P=(1/2)-0.01;
    else
        P=1-(fib_seq(N-i+1))/(fib_seq(N-i+2));
    end
    
a=zeros(1,N+1);
b=zeros(1,N+1);

a(1)=alpha_bracket(1);
b(1)=alpha_bracket(2);

a(i+1)=P*L + a(i);
b(i+1)=P*L + b(i);

alphak=a(i+1);
fa=eval(fnew);

alphak=b(i+1);
fb=eval(fnew);

if(fa<fb)
    new_bracket=[a(i);b(i+1)];
else
    new_bracket=[a(i+1);b(i)];
end

L=new_bracket(2)-new_bracket(1);
       
end


alpha_star=(new_bracket(1)+new_bracket(2))/2;
alphak=alpha_star;

else
    alpha_star=(alpha_bracket(1)+alpha_bracket(2));
    alphak=alpha_star;
end
% % End Fibonacci

newx=eval(tempx);
newx=double(newx);

if(abs(newx-oldx)<0.001)
    xnewtonm=newx;
    stop=1;
else
    syms alphak;
    oldx=newx;
end

end
% % modified newton end


end

